//Generated by the protocol buffer compiler. DO NOT EDIT!
// source: dsepractice/chinese/v1alpha1/core_types.proto

package gg.dsepractice.chinese.v1alpha1;

@kotlin.jvm.JvmName("-initializepaginationOption")
inline fun paginationOption(block: gg.dsepractice.chinese.v1alpha1.PaginationOptionKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.PaginationOption =
  gg.dsepractice.chinese.v1alpha1.PaginationOptionKt.Dsl._create(gg.dsepractice.chinese.v1alpha1.PaginationOption.newBuilder()).apply { block() }._build()
object PaginationOptionKt {
  @kotlin.OptIn(com.google.protobuf.kotlin.OnlyForUseByGeneratedProtoCode::class)
  @com.google.protobuf.kotlin.ProtoDslMarker
  class Dsl private constructor(
    private val _builder: gg.dsepractice.chinese.v1alpha1.PaginationOption.Builder
  ) {
    companion object {
      @kotlin.jvm.JvmSynthetic
      @kotlin.PublishedApi
      internal fun _create(builder: gg.dsepractice.chinese.v1alpha1.PaginationOption.Builder): Dsl = Dsl(builder)
    }

    @kotlin.jvm.JvmSynthetic
    @kotlin.PublishedApi
    internal fun _build(): gg.dsepractice.chinese.v1alpha1.PaginationOption = _builder.build()

    /**
     * <code>optional string cursor = 1 [json_name = "cursor"];</code>
     */
    var cursor: kotlin.String
      @JvmName("getCursor")
      get() = _builder.getCursor()
      @JvmName("setCursor")
      set(value) {
        _builder.setCursor(value)
      }
    /**
     * <code>optional string cursor = 1 [json_name = "cursor"];</code>
     */
    fun clearCursor() {
      _builder.clearCursor()
    }
    /**
     * <code>optional string cursor = 1 [json_name = "cursor"];</code>
     * @return Whether the cursor field is set.
     */
    fun hasCursor(): kotlin.Boolean {
      return _builder.hasCursor()
    }

    /**
     * <code>optional int32 limit = 2 [json_name = "limit"];</code>
     */
    var limit: kotlin.Int
      @JvmName("getLimit")
      get() = _builder.getLimit()
      @JvmName("setLimit")
      set(value) {
        _builder.setLimit(value)
      }
    /**
     * <code>optional int32 limit = 2 [json_name = "limit"];</code>
     */
    fun clearLimit() {
      _builder.clearLimit()
    }
    /**
     * <code>optional int32 limit = 2 [json_name = "limit"];</code>
     * @return Whether the limit field is set.
     */
    fun hasLimit(): kotlin.Boolean {
      return _builder.hasLimit()
    }
  }
}
inline fun gg.dsepractice.chinese.v1alpha1.PaginationOption.copy(block: gg.dsepractice.chinese.v1alpha1.PaginationOptionKt.Dsl.() -> kotlin.Unit): gg.dsepractice.chinese.v1alpha1.PaginationOption =
  gg.dsepractice.chinese.v1alpha1.PaginationOptionKt.Dsl._create(this.toBuilder()).apply { block() }._build()

